#ifndef MISSING_H_
#define MISSING_H_
#include "ivec.h"
#include "imat.h"
#include "random.h"
// for the moment this is written purely for
// models with 2 alleles per locus but I will
// change this for later versions
//
//  first little class for returning the locus
//  and individual missing.
//
class gpair {
public:
	int locus;
	int individual;
};
//
//
//
class missing {
 public:
  missing(imat &g);   
  missing(); 
  ~missing();
  //
  gpair rndmissing(rng &r=globalrandom);
  //
  int nmissing();
  bool operator() (){return  (_nmissing!=0);}
  //
  missing &operator =(const missing &m);
 private:
  int _nmissing;
  ivec missing_ind,missing_locus; 
  missing(const missing &m); 

};
void unvar(imat &g,rng &r=globalrandom);
#endif
