// factor.h: interface for the factor class.
//
//////////////////////////////////////////////////////////////////////
//
//  The factor class is a way of using an array of labels by turning
//  then into a integer vector from 0 to classes-1
//  
//
#if !defined(AFX_FACTOR_H__A93B1451_5699_11D5_84A7_00A0C9E4283F__INCLUDED_)
#define AFX_FACTOR_H__A93B1451_5699_11D5_84A7_00A0C9E4283F__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <map>
#include "ivec.h"

using namespace::std;

typedef map<int,int>::iterator map_itor;

class factor : public ivec  
{
public:
	factor(const ivec &vals);
	factor(void);
	factor(char *filename);
	int &element(int i){return code[_data[i-1]];}
	virtual ~factor();
	//
	factor &operator=(const factor &a);
	int classes(){return code.size();}
	int key(int i);
	//
	void factor::printutil();
private:
	void factor::getcode();
	map<int,int> code;
};

#endif // !defined(AFX_FACTOR_H__A93B1451_5699_11D5_84A7_00A0C9E4283F__INCLUDED_)
