#include "genotype.h"


gdata::gdata(int loci, int ploidy) 
{
	assign(loci);
}

void gdata::assign(int loci, int ploidy)
{
	assert(loci>0);
	_data = new int[ploidy*loci];
	_nloci=loci;
	_ploidy=ploidy;
}

gdata::~gdata()
{
	assert(_nloci>0);
	delete[] _data;
	_nloci=0;
	_ploidy=0;
}

ivec gdata::operator [] (int locus)
{
	assert(locus>1&&locus<_nloci);
	ivec tmp(_data+(_ploidy*locus),_ploidy);
	return tmp;
}
