
#ifndef MYIO_H_
#define  MYIO_H_
#include <iostream>
#include <fstream>
#include <vector>
#include <string>
#include "dvec.h"
using namespace::std;
// utility functions
int skipspace(istream &in);
int skipblank(istream &in, char until='\n');
int skipline(istream &in);
int nextname(istream &in, char *filename);
int findstart(istream &in,char *pattern);

int findstartcomment(istream  &in,char *pattern, char comment);
// input functions
int  scan(istream &in, char *namestring,int default_val);
bool scan(istream &in, char *namestring,bool default_val);
char scan(istream &in, char *namestring, char default_val);
// now for doubles etc
double scan(istream &in, char *namestring,double default_val);
double get_doubleval(istream &in);
int nextint(istream &in);
double nextdouble(istream &in);
string nextstring(istream &in);
// functions including strings
char *namescan(istream &in, char *namestring, char *default_val);
bool findparametername(istream &in, const char *pattern);
//
vector <int> readintvector(istream &in,bool usechar=false, char until='\n');
vector <int> readcharintmat(istream &in,int &cols, bool usechar=false);
vector <double> readdoublemat(istream &in,int &cols);
vector <double> readdoublevector(istream &in, char until='\n');
//
#endif

