#ifndef RAGGEDI_H_
#define RAGGEDI_H_
#include "ivec.h"
#include <iostream>
using namespace::std;
class iragged {
 public:
  // constructors and destructors
  iragged(int *x,int *len, int n, int totl);
  iragged(ivec &x);
  iragged(const iragged &a);
  iragged(void);
  ~iragged(void);
  // assigment operator
  iragged &operator=(const iragged &a);
  //  helper functions
  void allocate(int n, int totl);
  void destroy();
  void assign(int *len, int *x);
  // printing
  ostream &print(ostream &o);
  //
  int rows(){return _rows;}
  int cols(int i){return _cols[i-1];}
  // elements for 
  int &elem(int row, int col){return *(_r[row-1]+col-1);}
  int &operator()(int row, int col){return *(_r[row]+col);}
  //  int *operator(){int row){return _r[row];}
  int *operator[](int row){return _r[row-1]-1;}
 private:
  int _rows,_totl;
  int *_cols;
  int **_r;
  int *_data;
};
ostream &operator<<(ostream &o, const iragged &a);
#endif
