#ifndef RESULTS_H_
#define RESULTS_H_

#include <iostream>
#include "haplist.h"
#include "chain.h"
#include "factor.h"
using namespace::std;

class results {
 public:
  results();
  results(int n);
  results &operator=(const results &a);
  ~results();
  void addresults(chain &c);
  void printres(ostream &o, imat &d, int replicates=0);
  void printreslabel(ostream &o,  imat &d, int replicates,factor  &label);
  void printprop(ostream &o);
  void bestoverall(haplist &hl,  imat &d);
 private:
  int _nhap;
  haplist *res;
};

#endif
